# Untitled - By: karven - pe huhti 30 2021

import sensor, image, time

sensor.reset()                      # Reset and initialize the sensor.
sensor.set_pixformat(sensor.RGB565) # Set pixel format to RGB565 (or GRAYSCALE)
sensor.set_framesize(sensor.QVGA)   # Set frame size to QVGA (320x240)

clock = time.clock()                # Create a clock object to track the FPS.

# The gain db ceiling maxes out at about 24 db for the OV7725 sensor.
#sensor.set_auto_gain(True, gain_db_ceiling = 16.0) # Default gain.
clock.tick()
# Note! If you set the gain ceiling to low without adjusting the exposure control
# target value then you'll just get a lot of oscillation from the exposure
# control if it's on.
sensor.skip_frames(time = 2000)     # Wait for settings take effect.
img = sensor.snapshot()

gain_db1 = sensor.get_gain_db()
exposure_us1 = sensor.get_exposure_us()
red_db1, green_db1, blue_db1 = sensor.get_rgb_gain_db()
print(gain_db1, exposure_us1, red_db1, green_db1, blue_db1)

sensor.skip_frames(time = 2000)     # Wait for settings take effect.
img = sensor.snapshot()
gain_db2 = sensor.get_gain_db()
exposure_us2 = sensor.get_exposure_us()
red_db2, green_db2, blue_db2 = sensor.get_rgb_gain_db()
print(gain_db2, exposure_us2, red_db2, green_db2, blue_db2)

img = sensor.snapshot()
gain_db = int((gain_db1 + gain_db2)/2)
exposure_us = int((exposure_us1 + exposure_us2)/2)
red_db = (red_db1+ red_db2)/2
green_db = (green_db1 +green_db2)/2
blue_db = (blue_db1 + blue_db2 )/2
print(gain_db, exposure_us, red_db, green_db, blue_db)

sensor.set_auto_gain(False, gain_db_ceiling = gain_db ) # Default gain.
sensor.set_auto_exposure(False,exposure_us = exposure_us )
sensor.set_auto_whitebal(False, rgb_gain_db = (red_db, green_db, blue_db))

sensor.skip_frames(time = 2000)     # Wait for settings take effect.


while(True):
    clock.tick()                    # Update the FPS clock.
    img = sensor.snapshot()         # Take a picture and return the image.
    print("FPS %f, Gain %f dB, Exposure %d us" % \
        (clock.fps(), sensor.get_gain_db(), sensor.get_exposure_us()))
    print( "clours", sensor.get_rgb_gain_db())   # Prints the AWB current RGB gains.
